/****************************************************************************
 MADE BY BEN. BEN IS COOL. Feb 6, 2017
 Copyright Noodlecake Studios Inc. All rights reserved.
 ****************************************************************************/

#include "NoodleBinkBridge.h"
#include <android/asset_manager_jni.h>

#define  CLASS_NAME "com/noodlecake/NoodleBink/NoodleBinkBridge"

extern "C" {

    jint Java_com_noodlecake_BinkANE_BinkController_initBinkJNI(JNIEnv*  env, jobject thiz, jobject javaMgr, jboolean useObb, jstring obbPath) {
        AAssetManager *mgr = AAssetManager_fromJava(env, javaMgr);
        const char* c_obbPath = env->GetStringUTFChars(obbPath, 0);
        std::string cpp_obbPath(c_obbPath);
        int ret = NoodleBinkController::sharedController()->initBink(mgr, (bool)useObb, cpp_obbPath);
        return (jint)ret;
    }

    void Java_com_noodlecake_BinkANE_BinkController_reinitBinkJNI(JNIEnv*  env, jobject thiz, jobject javaMgr) {
        AAssetManager *mgr = AAssetManager_fromJava(env, javaMgr);
        NoodleBinkController::sharedController()->reinitBink(mgr);
        return;
    }

    jint Java_com_noodlecake_BinkANE_BinkController_loadVideoJNI(JNIEnv*  env, jobject thiz, jstring path, jlong offset) {
        const char *pathChars = env->GetStringUTFChars(path, NULL);
        std::string pathStr(pathChars);
        env->ReleaseStringUTFChars(path, pathChars);
        int ret = NoodleBinkController::sharedController()->loadVideo(pathStr, (long)offset);
        return (jint)ret;
    }

    jint Java_com_noodlecake_BinkANE_BinkController_getTotalFramesJNI(JNIEnv*  env, jobject thiz) {
        int ret = NoodleBinkController::sharedController()->getTotalFrames();
        return (jint)ret;
    }

    jboolean Java_com_noodlecake_BinkANE_BinkController_nextFrameJNI(JNIEnv*  env, jobject thiz) {
        bool ret = NoodleBinkController::sharedController()->nextFrame();
        return (jboolean)ret;
    }

    jboolean Java_com_noodlecake_BinkANE_BinkController_gotoFrameJNI(JNIEnv*  env, jobject thiz, jint frame) {
        bool ret = NoodleBinkController::sharedController()->gotoFrame((int)frame);
        return (jboolean)ret;
    }

    void Java_com_noodlecake_BinkANE_BinkController_setdrawJNI(JNIEnv*  env, jobject thiz, jdouble nx0, jdouble ny0, jdouble nx1, jdouble ny1){
        NoodleBinkController::sharedController()->setdraw((double)nx0, (double)ny0, (double)nx1, (double)ny1);
    }

    void Java_com_noodlecake_BinkANE_BinkController_drawJNI(JNIEnv*  env, jobject thiz) {
        NoodleBinkController::sharedController()->draw();
    }
}
