/****************************************************************************
//  Created by Ben Schmidt on Jan 19, 2017
//  Copyright (c) 2017 Noodlecake Studios Inc. All rights reserved.
 ****************************************************************************/

package com.noodlecake.BinkANE.functions;

import com.noodlecake.BinkANE.BinkController;
import com.noodlecake.BinkANE.Extension;
import android.util.Log;

import com.adobe.fre.FREContext;
import com.adobe.fre.FREFunction;
import com.adobe.fre.FREObject;

public class focusAdd implements FREFunction
{
	public FREObject call(FREContext context, FREObject[] args)
	{
        try {
            if(Extension.DEBUG_MODE) Log.d(Extension.EXT_LOG_TAG, "Entering focusAdd");

            String focusName = args[0].getAsString();
            double y = args[1].getAsDouble();
            double x = args[2].getAsDouble();
            double w = args[3].getAsDouble();
            double h = args[4].getAsDouble();
            BinkController.focusAdd(focusName, y, x, w, h);

            if(Extension.DEBUG_MODE) Log.d(Extension.EXT_LOG_TAG, "Exiting focusAdd");
            
            return null;
            
        } catch (Exception e) {
            Log.d(Extension.EXT_LOG_TAG, "Error in focusAdd - " + e.toString());
            return null;
        }
	}
}