/****************************************************************************
//  Created by Ben Schmidt on Jan 19, 2017
//  Copyright (c) 2017 Noodlecake Studios Inc. All rights reserved.
 ****************************************************************************/

package com.noodlecake.BinkANE.functions;

import com.noodlecake.BinkANE.BinkController;
import com.noodlecake.BinkANE.Extension;
import android.util.Log;

import android.content.res.AssetManager;
import android.app.Activity;

import com.adobe.fre.FREContext;
import com.adobe.fre.FREFunction;
import com.adobe.fre.FREObject;
import com.adobe.fre.FREByteArray;

import java.io.InputStream;
import java.io.IOException;
import java.nio.ByteBuffer;

public class getBytesFor implements FREFunction
{
    public FREObject call(FREContext context, FREObject[] args)
	{
        try {
            String name = args[0].getAsString();
            if(Extension.DEBUG_MODE) Log.d(Extension.EXT_LOG_TAG, "Entering getBytesFor " + name);

            byte[] data = BinkController.getBytesFor(name);

            if (null == data) {
                if(Extension.DEBUG_MODE) Log.d(Extension.EXT_LOG_TAG, "Failed to get bytes for file " + name);
                return null;
            }

            FREByteArray byteArray = (FREByteArray)args[1];
            FREObject length = FREObject.newObject(data.length);
            byteArray.setProperty("length", length);
            byteArray.acquire();
            ByteBuffer bytes = byteArray.getBytes();
            bytes.put(data);
            byteArray.release();

            if(Extension.DEBUG_MODE) Log.d(Extension.EXT_LOG_TAG, "Exiting getBytesFor " + name);
            
            return null;

        } catch (Exception e) {
            Log.d(Extension.EXT_LOG_TAG, "Error in getBytesFor - " + e.toString());
            return null;
        }
	}
}