/****************************************************************************
//  Created by Ben Schmidt on Jan 19, 2017
//  Copyright (c) 2017 Noodlecake Studios Inc. All rights reserved.
 ****************************************************************************/

package com.noodlecake.BinkANE.functions;

import com.noodlecake.BinkANE.BinkController;
import com.noodlecake.BinkANE.Extension;
import android.util.Log;

import android.graphics.Bitmap;

import java.io.ByteArrayOutputStream;
import java.nio.ByteBuffer;

import com.adobe.fre.FREBitmapData;


import com.adobe.fre.FREContext;
import com.adobe.fre.FREFunction;
import com.adobe.fre.FREObject;

public class getLoadedImage implements FREFunction
{
	public FREObject call(FREContext context, FREObject[] args)
	{
        try {
            if(Extension.DEBUG_MODE) Log.d(Extension.EXT_LOG_TAG, "Entering getLoadedImage");

            String name = args[0].getAsString();

            Bitmap img = BinkController.getLoadedImage(name);
            
            FREBitmapData airBitmap = (FREBitmapData)args[1];
            airBitmap.acquire();
            ByteBuffer airBytes = airBitmap.getBits();

            img.copyPixelsToBuffer(airBytes);
            
            airBitmap.release();

            BinkController.deleteLoadedImage(name);

            if(Extension.DEBUG_MODE) Log.d(Extension.EXT_LOG_TAG, "Exiting getLoadedImage");
            
            return null;
            
        } catch (Exception e) {
            Log.d(Extension.EXT_LOG_TAG, "Error in getLoadedImage - " + e.toString());
            return null;
        }
	}
}