/****************************************************************************
//  Created by Ben Schmidt on Jan 19, 2017
//  Copyright (c) 2017 Noodlecake Studios Inc. All rights reserved.
 ****************************************************************************/

package com.noodlecake.BinkANE.functions;

import com.noodlecake.BinkANE.BinkController;
import com.noodlecake.BinkANE.Extension;
import android.util.Log;

import android.graphics.Bitmap;

import com.adobe.fre.FREContext;
import com.adobe.fre.FREFunction;
import com.adobe.fre.FREObject;

public class getLoadedImageInfo implements FREFunction
{
	public FREObject call(FREContext context, FREObject[] args)
	{
        try {
            if(Extension.DEBUG_MODE) Log.d(Extension.EXT_LOG_TAG, "Entering getLoadedImageInfo");

            String name = args[0].getAsString();

            Bitmap img = BinkController.getLoadedImage(name);

            FREObject info = FREObject.newObject("Object", null);
            FREObject width = FREObject.newObject(img.getWidth());
            FREObject height = FREObject.newObject(img.getHeight());
            info.setProperty("width", width);
            info.setProperty("height", height);

            if(Extension.DEBUG_MODE) Log.d(Extension.EXT_LOG_TAG, "Exiting getLoadedImageInfo");
            
            return info;
            
        } catch (Exception e) {
            Log.d(Extension.EXT_LOG_TAG, "Error in getLoadedImageInfo - " + e.toString());
            return null;
        }
	}
}