/****************************************************************************
//  Created by Ben Schmidt on Jan 19, 2017
//  Copyright (c) 2017 Noodlecake Studios Inc. All rights reserved.
 ****************************************************************************/

package com.noodlecake.BinkANE.functions;

import com.noodlecake.BinkANE.BinkController;
import com.noodlecake.BinkANE.Extension;
import com.noodlecake.BinkANE.ExtensionContext;
import android.util.Log;

import android.app.Activity;

import com.adobe.fre.FREContext;
import com.adobe.fre.FREFunction;
import com.adobe.fre.FREObject;
import com.adobe.air.AndroidActivityWrapper.ActivityState;  

public class icInitialise implements FREFunction
{
	public FREObject call(FREContext context, FREObject[] args)
	{
        try {
            if(Extension.DEBUG_MODE) Log.d(Extension.EXT_LOG_TAG, "Entering icInitialise");

            //AIR makes the original STARTED call to all listeners before we are able to register...
            ((ExtensionContext)context).onActivityStateChanged(ActivityState.STARTED);
            
            boolean controllerResult = BinkController.icInitialise(context);
            FREObject ret = FREObject.newObject(controllerResult);

            if(Extension.DEBUG_MODE) Log.d(Extension.EXT_LOG_TAG, "Exiting icInitialise");
            
            return ret;
            
        } catch (Exception e) {
            Log.d(Extension.EXT_LOG_TAG, "Error in icInitialise - " + e.toString());
            return null;
        }
	}
}