/****************************************************************************
//  Created by Ben Schmidt on Jan 19, 2017
//  Copyright (c) 2017 Noodlecake Studios Inc. All rights reserved.
 ****************************************************************************/

package com.noodlecake.BinkANE.functions;

import com.noodlecake.BinkANE.BinkController;
import com.noodlecake.BinkANE.Extension;
import android.util.Log;

import com.adobe.fre.FREContext;
import com.adobe.fre.FREFunction;
import com.adobe.fre.FREObject;

public class loadDualVideo implements FREFunction
{
	public FREObject call(FREContext context, FREObject[] args)
	{
        try {
            if(Extension.DEBUG_MODE) Log.d(Extension.EXT_LOG_TAG, "Entering loadDualVideo");

            String file = args[0].getAsString();
            String folder = args[1].getAsString();
            int controllerResult = BinkController.loadDualVideo(file, folder);
            FREObject ret = FREObject.newObject(controllerResult);

            if(Extension.DEBUG_MODE) Log.d(Extension.EXT_LOG_TAG, "Exiting loadDualVideo");
            
            return ret;
            
        } catch (Exception e) {
            Log.d(Extension.EXT_LOG_TAG, "Error in loadDualVideo - " + e.toString());
            return null;
        }
	}
}