/****************************************************************************
 MADE BY BEN. BEN IS COOL. Dec 8, 2016
 ****************************************************************************/

package com.noodlecake.NoodleX;

import java.lang.ref.WeakReference;
import android.app.Activity;

import android.util.Log;
import android.os.Bundle;
import android.content.Intent;

import java.util.*;
import java.util.concurrent.Callable;

import java.io.*;

//ANALYTICS
import com.noodlecake.NoodleX.NoodleXFlurry;

//NATIVE
import com.noodlecake.NoodleX.NoodleXNative;
import com.noodlecake.NoodleX.NoodleXOBB;

//GPGS
import com.noodlecake.NoodleX.NoodleXGPGS;

//NOODLENEWS
import com.noodlecake.NoodleX.NoodleXNews;

//LOCALIZATION
import com.noodlecake.NoodleX.NoodleXLocalization;

public class NoodleXBridge {
    
    /***************************
     * CONSTANTS, DO NOT TOUCH *
     ***************************/
    //all NoodleX Logs will use this tag
    public static final String TAG = "NoodleX";

    //callback error codes
    public static final int NOODLEX_SUCCESS = 0;
    public static final int NOODLEX_ERROR = 1;
    public static final int NOODLEX_CANCEL = 2;
    public static final int NOODLEX_STARTING = 3;
    public static final int NOODLEX_IN_PROGRESS = 4;
    public static final int NOODLEX_PAUSED = 5;

    //permission request codes
    public static final int NO_PERMISSION = -1;
    public static final int NOODLEX_WRITE_EXTERNAL_STORAGE = 0;


    /************
     * SETTINGS *
     ************/
    //turns on debug logs
    public static Boolean debug = false;

    //minimum time between interstitials
    private static final int MILLIS_BETWEEN_INTERSTITIAL_ADS = 1000 * 60 * 2; //2 minutes
    
    //how many times we'll skip showing you an ad when you first install the game
    //for example, if your time between interstitials is 2 minutes, and you give 10 free passes
    //the user will have a minimum of 20 minutes without forced interstitials
    private static final int INTERSTITIAL_FREE_PASSES = 10;

    /*********************
     * PRIVATE VARIABLES * 
     *********************/
    private static WeakReference<Activity> mActivity;
    

    /*********
     * SETUP *
     *********/
    // must be called in the main thread - do this in OnCreate.
    public static void init(Activity activity){
        Log.d(TAG, "Initializing NoodleXBridge...");

    	mActivity = new WeakReference<Activity>(activity);

        /* LOCALIZATION */
        NoodleXLocalization.init(mActivity);

        /* ANALYTICS */
        NoodleXFlurry.init(mActivity);

        /* NATIVE */
        NoodleXNative.init(mActivity);
        NoodleXOBB.init(mActivity);

        /* GPGS */
        NoodleXGPGS.init(mActivity);

        // NoodleXNews
        NoodleXNews.init(mActivity);

        Log.d(TAG, "NoodleXBridge initialization complete!");
    }

    public static void setDebug(Boolean on) {
        debug = on;
    }

    /************
     HOOKS
     ************/
    public static void onCreate(final Bundle savedInstanceState, Activity activity) {
        init(activity);
    }

    public static void onResume() {
        NoodleXGPGS.onResume();
        NoodleXNative.onResume();
    }

    public static void onPause() {
        NoodleXGPGS.onPause();
    }
    
    public static void onDestroy() {

    }

    public static void onStart(){
        NoodleXFlurry.onStart();
    }
 
    public static void onStop(){
        NoodleXGPGS.onStop();
        NoodleXFlurry.onStop();
    }

    public static void onSaveInstanceState(Bundle outState) {

    }

    public static void onActivityResult(int requestCode, int resultCode, Intent data) {
        NoodleXGPGS.onActivityResult(requestCode, resultCode, data);
    }

    public static void onRequestPermissionsResult(int requestCode, String permissions[], int[] grantResults) {
        NoodleXNative.onRequestPermissionsResult(requestCode, permissions, grantResults);
    }

    public static void onWindowFocusChanged(boolean hasFocus) {
        NoodleXNative.onWindowFocusChanged(hasFocus);
    }

    /************
     ANALYTICS
     ************/
    public static void findAndSetUserID() {
        String id = NoodleXNative.getAdvertisingID();
        NoodleXFlurry.setUserId(id);
    }

    public static void setUserProperty(String propertyName, String value) {
        //FLURRY
        //flurry only lets you set very specific properties, just log an event instead
        HashMap<String,String> hm = new HashMap<String,String>();
        hm.put(propertyName, value);
        NoodleXFlurry.logEvent(propertyName, hm);

        //MIXPANEL
        //NoodleXMixpanel.setUserProperty(propertyName, value);
    }

    public static void logEvent(String eventName, HashMap<String,String> parameters) {
        //FLURRY
        NoodleXFlurry.logEvent(eventName, parameters);

        //MIXPANEL
        //NoodleXMixpanel.logEvent(eventName, parameters);
    }


    /************
     NATIVE
     ************/
    public static int getLaunchCount() {
        return NoodleXNative.getLaunchCount();
    }

    public static void shareText(String message) {
        NoodleXNative.shareText(message);
    }

    public static void shareImageWithText(String imgPath, String message) {
        NoodleXNative.shareImageWithText(imgPath, message);
    }

    public static String getPhotosDirectory() {
        return NoodleXNative.getPhotosDirectory();
    }

    public static void openURL(String url) {
        NoodleXNative.openURL(url);
    }

    public static String getVersionNumber() {
        return NoodleXNative.getVersionNumber();
    }

    public static int getVersionCode() {
        return NoodleXNative.getVersionCode();
    }

    public static void showOneButtonPopup(String title, String message, String button1Text, final Callable<Void> button1Callback) {
        NoodleXNative.showOneButtonPopup(title, message, button1Text, button1Callback);
    }

    public static void showTwoButtonPopup(String title, String message, 
    String button1Text, String button2Text, 
    final Callable<Void> button1Callback, final Callable<Void> button2Callback) {
        NoodleXNative.showTwoButtonPopup(title, message, button1Text, button2Text, button1Callback, button2Callback);
    }

    public static void showThreeButtonPopup(String title, String message, 
    String button1Text, String button2Text, String button3Text, 
    final Callable<Void> button1Callback, final Callable<Void> button2Callback, final Callable<Void> button3Callback) {
        NoodleXNative.showThreeButtonPopup(title, message, button1Text, button2Text, button3Text, button1Callback, button2Callback, button3Callback);
    }

    public static void showToast(String message) {
        NoodleXNative.showToast(message);
    }

    public static void requestPermission(int requestedPermissionInt) {
        NoodleXNative.requestPermission(requestedPermissionInt);
    }

    public static boolean havePermission(int requestedPermissionInt) {
        return NoodleXNative.havePermission(requestedPermissionInt);
    }

    public static void setPermissionCompleteCallback(Callable<Void> callback) {
        NoodleXNative.setPermissionCompleteCallback(callback);
    }


	public static void setImmersiveMode() {
        NoodleXNative.setImmersiveMode();
    }

    public static void keepScreenOn() {
        NoodleXNative.keepScreenOn();
    }

    /************
     OBB
     ************/
    public static boolean obbExists() {
        return NoodleXOBB.obbExists();
    }

    public static String getObbPath() {
        return NoodleXOBB.getObbPath();
    }

    public static void setObbDownloadStartedCallback(Callable<Void> callback) {
        NoodleXOBB.setObbDownloadStartedCallback(callback);
    }

    public static void setObbDownloadProgressCallback(Callable<Void> callback) {
        NoodleXOBB.setObbDownloadProgressCallback(callback);
    }

    public static void setObbDownloadCompleteCallback(Callable<Void> callback) {
        NoodleXOBB.setObbDownloadCompleteCallback(callback);
    }

    public static void setObbPreparedCallback(Callable<Void> callback) {
        NoodleXOBB.setObbPreparedCallback(callback);
    }

    public static boolean obbReady() {
        return NoodleXOBB.obbReady();
    }

    public static int getObbDownloadState() {
        return NoodleXOBB.getObbDownloadState();
    }

    public static long getObbDownloadProgress() {
        return NoodleXOBB.getObbDownloadProgress();
    }

    public static long getObbDownloadTotal() {
        return NoodleXOBB.getObbDownloadTotal();
    }

    public static float getObbDownloadPercent() {
        return NoodleXOBB.getObbDownloadPercent();
    }

    public static float getObbDownloadSpeed() {
        return NoodleXOBB.getObbDownloadSpeed();
    }

    public static long getObbDownloadTimeRemaining() {
        return NoodleXOBB.getObbDownloadTimeRemaining();
    }

    //Gets necessary permissions and downloads obb if necessary
	public static void prepareObb() {
        NoodleXOBB.prepareObb();
    }

     public static InputStream getObbInputStreamForFile(String obbFilepath) {
        return NoodleXOBB.getInputStreamForFile(obbFilepath);
     }

     public static byte[] getObbBytesForFile(String obbFilepath) {
        return NoodleXOBB.getBytesForFile(obbFilepath);
     }

     public static long getObbOffsetForFile(String obbFilePath) {
        return NoodleXOBB.getOffsetForFile(obbFilePath);
     }

     public static File extractObbFile(String obbFilepath, String extractPath) {
        return NoodleXOBB.extractFile(obbFilepath, extractPath);
     }

     public static void extractEntireObb(String extractPath) {
        NoodleXOBB.extractEntireObb(extractPath);
     }

     public static void deleteObb() {
        NoodleXOBB.deleteObb();
     }

    /************
     GPGS
     ************/

     // Sets a callback to be called when Google Play has either connected or failed to connect
    public static void setAuthenticateCompleteCallback (Callable<Void> callback)
    {   
        NoodleXGPGS.setAuthenticateCompleteCallback(callback);
    }

    // Authenticate the GPGS API, hook this to the game's authenticate method (if it has one).
    public static void authenticateGPGS() {
        NoodleXGPGS.authenticate();
    }

    // Returns true if the user is authenticated, false otherwise
    public static Boolean isAuthenticatedGPGS() {
        return NoodleXGPGS.isAuthenticated();
    }

    // Handle the GPGS button being clicked
    public static void handleSignInSignOutGPGS() {     
        // Call on NoodleXGPGS!
        NoodleXGPGS.handleSignInSignOut();
    }

    // Handle the GPGS button being clicked
    public static void handleViewAchievements() {
        // Call on NoodleXGPGS!
        NoodleXGPGS.handleViewAchievements();
    }

     // Handle an achievement being unlocked, requires an achievement ID
    public static void handleUnlockAchievement(String achievementName) {
        // Call on NoodleXGPGS!
        NoodleXGPGS.handleUnlockAchievement(achievementName);
    }

     // Handle an achievement being unlocked, requires an achievement ID and increment
    public static void handleIncrementAchievement(String achievementName, int increment) {
        // Call on NoodleXGPGS!
        NoodleXGPGS.handleIncrementAchievement(achievementName, increment);
    }
    
    /* CLOUD SAVE */
    // Returns the string of data returned from a cloudload.
    public static String getCloudSaveString() {
        return NoodleXGPGS.getCloudSaveString();
    }
    // Sets the callback method. MUST be called by the GAME, as soon as possible (before any GPGS authentication happens).
    public static void setCloudLoadCallback(Callable<Void> callback) {   
        NoodleXGPGS.setCloudLoadCallback(callback);
    }

    // Load data from cloud, requires save index from which to load
    public static void loadFromCloud(Integer index) {
        NoodleXGPGS.loadFromCloud(index);
    }

    // Saves data to cloud, requires save index and data in string form.
    public static void saveToCloud (Integer index, String data, boolean forceSave) {
        NoodleXGPGS.saveToCloud(index, data, forceSave);
    }

    /***************
       NOODLE NEWS
     ***************/
    public static void showCreative() {
        NoodleXNews.showNoodleNewsCreative();
    }
    public static void showMoreGames() {
        NoodleXNews.showMoreGames();
    }
    // This method is what is called via the callable to check if audio should be muted
    public static boolean noodlenewsMuteAudio() {
        return NoodleXNews.noodlenewsMuteAudio();
    }
    // Sets the callback method. MUST be called by the GAME, as soon as possible (before any GPGS authentication happens).
    public static void setCreativesCallable(Callable<Void> callable) {   
        NoodleXNews.setCreativesCallable(callable);
    }

    /***************
       LOCALIZATION
     ***************/
    public static String getLanguageCode() {
        return NoodleXLocalization.getLanguageCode();
    }

    public static String getCountryCode() {
        return NoodleXLocalization.getCountryCode();
    }

    public static String getLocalizationCode() {
        return NoodleXLocalization.getLocalizationCode();
    }

    public static String getLocalizedMessage(String key) {
        return NoodleXLocalization.getMessage(key);
    }

    public static void setLocalization(String language) {
        NoodleXLocalization.setLocalization(language);
    }

    public static void setGameLocalizationFile(String fileName) {
        NoodleXLocalization.setGameLocalizations(fileName);
    }
}