/****************************************************************************
 MADE BY JASON. JASON IS COOL. Mar something, 2016
 ****************************************************************************/

package com.noodlecake.NoodleX;

/*
Must be linked with
	androidsdk/extras/google/play_apk_expansion/downloader_library/bin/downloader_library.jar
	androidsdk/extras/google/play_licensing/library/bin/library.jar
	androidsdk/extras/google/play_apk_expansion/zip_file/bin/zip_file.jar
*/

import com.noodlecake.NoodleX.NoodleXBridge;

import java.io.File;
import java.io.FileOutputStream;
import java.io.FilenameFilter;
import java.io.InputStream;
import java.lang.ref.WeakReference;
import java.util.concurrent.Callable;

import android.app.Activity;
import android.app.PendingIntent;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.pm.ActivityInfo;
import android.content.pm.PackageManager;
import android.content.pm.PackageManager.NameNotFoundException;
import android.os.Messenger;
import android.util.Log;
import android.os.Build;

import com.android.vending.expansion.zipfile.APKExpansionSupport;
import com.android.vending.expansion.zipfile.ZipResourceFile;
import com.android.vending.expansion.zipfile.ZipResourceFile.ZipEntryRO;

import com.google.android.vending.expansion.downloader.DownloadProgressInfo;
import com.google.android.vending.expansion.downloader.DownloaderClientMarshaller;
import com.google.android.vending.expansion.downloader.Helpers;
import com.google.android.vending.expansion.downloader.IDownloaderClient;
import com.google.android.vending.expansion.downloader.IStub;
import com.google.android.vending.expansion.downloader.impl.DownloaderService;
import com.google.android.vending.expansion.downloader.IDownloaderService;
import com.google.android.vending.expansion.downloader.DownloaderServiceMarshaller;

import com.noodlecake.NoodleX.NoodleXObbDownloaderService;
import com.noodlecake.NoodleX.NoodleXObbAlarmReceiver;

public class NoodleXOBB implements IDownloaderClient {

	private static IStub mDownloaderClientStub;
    private static IDownloaderService mRemoteService;
	private static WeakReference<Activity> mActivity;
	
	private static NoodleXOBB mInstance;

    private static String obbPath;

    private static int downloadState;
    private static long downloadProgress;
    private static long downloadTotal;
    private static float downloadSpeed;
    private static long downloadTimeRemaining;
    private static boolean obbReady;

    private static Callable<Void> obbDownloadStartedCallback;
    private static Callable<Void> obbDownloadProgressCallback;
    private static Callable<Void> obbDownloadCompleteCallback;       
    private static Callable<Void> obbPreparedCallback;  

    private static ZipResourceFile expansionFile;

    public static void init(WeakReference<Activity> activity){
        if (NoodleXBridge.debug) Log.d(NoodleXBridge.TAG, "OBB~ Initializing NoodleXOBB...");

    	mActivity = activity;
        mInstance = new NoodleXOBB();
        obbReady = false;

        try {
            int versionCode = NoodleXBridge.getVersionCode();
            if (NoodleXBridge.debug) Log.d(NoodleXBridge.TAG, "OBB~ Version code is " + versionCode);

            obbPath = null;
            String obbDir = Helpers.generateSaveFileName(mActivity.get(), "");

            //check for any file named main... in the directory
            File dir = new File(obbDir);
            File [] files = dir.listFiles(new FilenameFilter() {
                @Override
                public boolean accept(File dir, String name) {
                    return name.startsWith("main.");
                }
            });

            if (files != null) {
                for (File obbFile : files) {
                    obbPath = obbDir + obbFile.getName();
                }
            }
            
            if (obbPath == null) {
                String obbFile = Helpers.getExpansionAPKFileName(mActivity.get(), true, versionCode);
                obbPath = obbDir + obbFile;
            }

            if (NoodleXBridge.debug) Log.d(NoodleXBridge.TAG, "OBB~ OBB path is " + obbPath);

        } catch (Exception e) {
            Log.e(NoodleXBridge.TAG, "OBB~ Error during NoodleXOBB initialization: " + e.toString());
        }

        if (NoodleXBridge.debug) Log.d(NoodleXBridge.TAG, "OBB~ NoodleXOBB initialization complete!");
    }

    /*************************
     * SETUP AND DOWNLOADING *
     *************************/

    public static boolean obbExists() {
        File fileForNewFile = new File(obbPath);
        if (fileForNewFile.exists()) {
    		if (NoodleXBridge.debug) Log.d(NoodleXBridge.TAG, "OBB~ obb exists at: " + obbPath + " and has size " + fileForNewFile.length());
            return true;
        }
        if (NoodleXBridge.debug) Log.d(NoodleXBridge.TAG, "OBB~ obb does not exist: " + obbPath);
        return false;
    }

    public static String getObbPath() {
        return obbPath;
    }

    public static void setObbDownloadStartedCallback(Callable<Void> callback) {
        obbDownloadStartedCallback = callback;
    }

    public static void setObbDownloadProgressCallback(Callable<Void> callback) {
        obbDownloadProgressCallback = callback;
    }

    public static void setObbDownloadCompleteCallback(Callable<Void> callback) {
        obbDownloadCompleteCallback = callback;
    }

    public static void setObbPreparedCallback(Callable<Void> callback) {
        obbPreparedCallback = callback;
    }

    public static int getObbDownloadState() {
        return downloadState;
    }

    public static long getObbDownloadProgress() {
        return downloadProgress;
    }

    public static long getObbDownloadTotal() {
        return downloadTotal;
    }

    public static float getObbDownloadPercent() {
        return ((float)downloadProgress)/((float)downloadTotal);
    }

    public static float getObbDownloadSpeed() {
        return downloadSpeed;
    }

    public static long getObbDownloadTimeRemaining() {
        return downloadTimeRemaining;
    }

    public static boolean obbReady() {
        return obbReady;
    }

    public static void prepareObb() {
        //make sure we have write external first of all - certain versions of Android require it to read the obb
        Callable<Void> permissionCallback = new Callable<Void>()
        {
            public Void call()
            {   
                if (Build.VERSION.SDK_INT != 23 || NoodleXBridge.havePermission(NoodleXBridge.NOODLEX_WRITE_EXTERNAL_STORAGE)){
                    //we have the permission! check on obb status...
                    if (!obbExists()) {
                        //no obb downloaded, get that now
                        downloadObb();
                    } else {
                        //we have the obb and the permission! good to go!
                        obbReady = true;

                        try {
                            expansionFile = new ZipResourceFile(obbPath);
                        } catch (Exception e) {
                            Log.e(NoodleXBridge.TAG, "OBB~ Error creating ZipResourceFile: " + e.toString());
                        }

                        if (obbPreparedCallback != null) {
                            try {
                                obbPreparedCallback.call();
                            } catch (Exception e) {
                                Log.e(NoodleXBridge.TAG, "OBB~ Error in obbPreparedCallback: " + e.toString());
                            }
                        }
                    }
                } else {
                    //look man, we really need this permission
                    if (NoodleXBridge.debug) Log.d(NoodleXBridge.TAG, "Permission wasn't granted - asking the user again.");
                    NoodleXBridge.showTwoButtonPopup(NoodleXBridge.getLocalizedMessage("NC_AcceptPermission"), 
                    NoodleXBridge.getLocalizedMessage("NC_PermissionRequiredRun"), 
                    NoodleXBridge.getLocalizedMessage("NC_Retry"), 
                    NoodleXBridge.getLocalizedMessage("NC_Cancel"), 
                    new Callable<Void>()
                    {
                        public Void call() {   
                            //retry
                            NoodleXBridge.requestPermission(NoodleXBridge.NOODLEX_WRITE_EXTERNAL_STORAGE);
                            return null;
                        }
                    }, 
                    new Callable<Void>()
                    {
                        public Void call() {   
                            //cancel
                            if (obbPreparedCallback != null) {
                                try {
                                    obbPreparedCallback.call();
                                } catch (Exception e) {
                                    Log.e(NoodleXBridge.TAG, "OBB~ Error in obbPreparedCallback: " + e.toString());
                                }
                            }
                            return null;
                        }
                    });
                }
                return null;
            }
        };

        //We need write external on Android 6 because Google screwed up and OBBs don't work until you restart your phone otherwise
        if (Build.VERSION.SDK_INT == 23) {
            NoodleXBridge.setPermissionCompleteCallback(permissionCallback);
            NoodleXBridge.requestPermission(NoodleXBridge.NOODLEX_WRITE_EXTERNAL_STORAGE);
        } else {
            try {
                permissionCallback.call();
            } catch (Exception e) {
                Log.e(NoodleXBridge.TAG, "OBB~ Error calling OBB permission callback: " + e.toString());
            }
        }
    }

	private static void downloadObb() {
		// expansion file downloading
        if (!obbExists()) {
        	if (NoodleXBridge.debug) Log.d(NoodleXBridge.TAG, "OBB~ !expansionFilesDelivered");

            // Build an Intent to start this activity from the Notification
            Intent notifierIntent = new Intent(mActivity.get(), mActivity.get().getClass());
            notifierIntent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK |
                                    Intent.FLAG_ACTIVITY_CLEAR_TOP);
            notifierIntent.setPackage("com.android.vending");
            PendingIntent pendingIntent = PendingIntent.getActivity(mActivity.get(), 0,
                    notifierIntent, PendingIntent.FLAG_UPDATE_CURRENT);

            // Start the download service (if required)
            int startResult = 0;
			try {
				startResult = DownloaderClientMarshaller.startDownloadServiceIfRequired(mActivity.get(),
                            pendingIntent, NoodleXObbDownloaderService.class);
				
				if (NoodleXBridge.debug) Log.d(NoodleXBridge.TAG, "OBB~ startDownloadServiceIfRequired(" + startResult + ")");
			} catch (Exception e) {
				Log.e(NoodleXBridge.TAG, "OBB~ Error starting the OBB download service");
			}

            // If download has started, initialize this activity to show
            // download progress
            if (startResult != DownloaderClientMarshaller.NO_DOWNLOAD_REQUIRED) {
                if (NoodleXBridge.debug) Log.d(NoodleXBridge.TAG, "OBB~ DownloaderClientMarshaller.CreateStub(mInstance, NoodleXObbDownloaderService.class)");
            	mDownloaderClientStub = DownloaderClientMarshaller.CreateStub(mInstance, NoodleXObbDownloaderService.class);
                mDownloaderClientStub.connect(mActivity.get());

                if (obbDownloadStartedCallback != null) {
                    try {
                        obbDownloadStartedCallback.call();
                    } catch (Exception e) {
                        Log.e(NoodleXBridge.TAG, "OBB~ Error in obbDownloadStartedCallback");
                    }
                }

            	return;
            }
        }

        if (obbDownloadCompleteCallback != null) {
            try {
                obbDownloadCompleteCallback.call();
            } catch (Exception e) {
                Log.e(NoodleXBridge.TAG, "OBB~ Error in obbDownloadCompleteCallback");
            }
        }

        obbReady = true;
        
        try {
            expansionFile = new ZipResourceFile(obbPath);
        } catch (Exception e) {
            Log.e(NoodleXBridge.TAG, "OBB~ Error creating ZipResourceFile: " + e.toString());
        }

        if (obbPreparedCallback != null) {
            try {
                obbPreparedCallback.call();
            } catch (Exception e) {
                Log.e(NoodleXBridge.TAG, "OBB~ Error in obbPreparedCallback: " + e.toString());
            }
        }
	}

    public static void onStart() {
		if (null != mDownloaderClientStub) {
            if (NoodleXBridge.debug) Log.d(NoodleXBridge.TAG, "OBB~ onStart connecting...");
            mDownloaderClientStub.connect(mActivity.get());
        }
	}

	public static void onStop() {
		if (null != mDownloaderClientStub) {
            if (NoodleXBridge.debug) Log.d(NoodleXBridge.TAG, "OBB~ onStop disconnecting...");
            mDownloaderClientStub.disconnect(mActivity.get());
        }
	}
	
	// IDownloaderClient interface
	@Override
	public void onServiceConnected(Messenger m) {
		if (NoodleXBridge.debug) Log.d(NoodleXBridge.TAG, "OBB~ onServiceConnected");
        mRemoteService = DownloaderServiceMarshaller.CreateProxy(m);
        mRemoteService.onClientUpdated(mDownloaderClientStub.getMessenger());
	}

	@Override
	public void onDownloadStateChanged(int newState) {
		if (NoodleXBridge.debug) Log.d(NoodleXBridge.TAG, "OBB~ onDownloadStateChanged(" + newState + ", " + Helpers.getDownloaderStringResourceIDFromState(newState) + ")");

        switch (newState) {
            case IDownloaderClient.STATE_IDLE:
            case IDownloaderClient.STATE_FETCHING_URL:
            case IDownloaderClient.STATE_CONNECTING:
                if (NoodleXBridge.debug) Log.d(NoodleXBridge.TAG, "OBB~ Downlod state: STARTING " + newState);
                downloadState = NoodleXBridge.NOODLEX_STARTING;

                if (obbDownloadProgressCallback != null) {
                    try {
                        obbDownloadProgressCallback.call();
                    } catch (Exception e) {
                        Log.e(NoodleXBridge.TAG, "OBB~ Error in obbDownloadProgressCallback");
                    }
                }

                break;
            case IDownloaderClient.STATE_DOWNLOADING:
                if (NoodleXBridge.debug) Log.d(NoodleXBridge.TAG, "OBB~ Downlod state: IN PROGRESS");
                downloadState = NoodleXBridge.NOODLEX_IN_PROGRESS;
                //Downloading additional files...
                NoodleXBridge.showToast(NoodleXBridge.getLocalizedMessage("NC_DownloadingAdditional") + "\n" + NoodleXBridge.getLocalizedMessage("NC_CheckNotifications"));

                if (obbDownloadProgressCallback != null) {
                    try {
                        obbDownloadProgressCallback.call();
                    } catch (Exception e) {
                        Log.e(NoodleXBridge.TAG, "OBB~ Error in obbDownloadProgressCallback");
                    }
                }

                break;
            case IDownloaderClient.STATE_COMPLETED:
                if (NoodleXBridge.debug) Log.d(NoodleXBridge.TAG, "OBB~ Downlod state: COMPLETED");
                downloadState = NoodleXBridge.NOODLEX_SUCCESS;
                //Download complete. Preparing game for first launch...
                String messageComplete = NoodleXBridge.getLocalizedMessage("NC_DownloadComplete")+" "+NoodleXBridge.getLocalizedMessage("NC_PreparingFirstLaunch");
                NoodleXBridge.showToast(messageComplete);

                if (obbDownloadCompleteCallback != null) {
                    try {
                        obbDownloadCompleteCallback.call();
                    } catch (Exception e) {
                        Log.e(NoodleXBridge.TAG, "OBB~ Error in obbDownloadCompleteCallback");
                    }
                }

                obbReady = true;
                try {
                    expansionFile = new ZipResourceFile(obbPath);
                } catch (Exception e) {
                    Log.e(NoodleXBridge.TAG, "OBB~ Error creating ZipResourceFile: " + e.toString());
                }

                if (obbPreparedCallback != null) {
                    try {
                        obbPreparedCallback.call();
                    } catch (Exception e) {
                        Log.e(NoodleXBridge.TAG, "OBB~ Error in obbPreparedCallback: " + e.toString());
                    }
                }

                break;
            case IDownloaderClient.STATE_PAUSED_NETWORK_UNAVAILABLE:
            case IDownloaderClient.STATE_PAUSED_BY_REQUEST:
            case IDownloaderClient.STATE_PAUSED_WIFI_DISABLED_NEED_CELLULAR_PERMISSION:
            case IDownloaderClient.STATE_PAUSED_NEED_CELLULAR_PERMISSION:
            case IDownloaderClient.STATE_PAUSED_WIFI_DISABLED:
            case IDownloaderClient.STATE_PAUSED_NEED_WIFI:
            case IDownloaderClient.STATE_PAUSED_ROAMING:
            case IDownloaderClient.STATE_PAUSED_NETWORK_SETUP_FAILURE:
            case IDownloaderClient.STATE_PAUSED_SDCARD_UNAVAILABLE:
                if (NoodleXBridge.debug) Log.d(NoodleXBridge.TAG, "OBB~ Downlod state: PAUSED " + newState);
                downloadState = NoodleXBridge.NOODLEX_PAUSED;
                //Download paused. Check the notification bar for details.
                NoodleXBridge.showOneButtonPopup(NoodleXBridge.getLocalizedMessage("NC_DownloadPaused"), 
                NoodleXBridge.getLocalizedMessage("NC_CheckNotifications"), 
                NoodleXBridge.getLocalizedMessage("NC_OK"), 
                null);

                if (obbDownloadProgressCallback != null) {
                    try {
                        obbDownloadProgressCallback.call();
                    } catch (Exception e) {
                        Log.e(NoodleXBridge.TAG, "OBB~ Error in obbDownloadProgressCallback");
                    }
                }
                
                break;
            case IDownloaderClient.STATE_FAILED_UNLICENSED:
            case IDownloaderClient.STATE_FAILED_FETCHING_URL:
            case IDownloaderClient.STATE_FAILED_SDCARD_FULL:
            case IDownloaderClient.STATE_FAILED_CANCELED:
            case IDownloaderClient.STATE_FAILED:
                if (NoodleXBridge.debug) Log.d(NoodleXBridge.TAG, "OBB~ Downlod state: FAILURE " + newState);
                downloadState = NoodleXBridge.NOODLEX_ERROR;
                //Download Failed. Check the notification bar for details and restart the application.
                NoodleXBridge.showOneButtonPopup(NoodleXBridge.getLocalizedMessage("NC_DownloadFailed"), 
                NoodleXBridge.getLocalizedMessage("NC_CheckNotificationsRestart"), 
                NoodleXBridge.getLocalizedMessage("NC_Exit"), 
                new Callable<Void>()
                {
                    public Void call() {   
                        if (obbDownloadCompleteCallback != null) {
                            try {
                                obbDownloadCompleteCallback.call();
                            } catch (Exception e) {
                                Log.e(NoodleXBridge.TAG, "OBB~ Error in obbDownloadCompleteCallback");
                            }
                        }

                        if (obbPreparedCallback != null) {
                            try {
                                obbPreparedCallback.call();
                            } catch (Exception e) {
                                Log.e(NoodleXBridge.TAG, "OBB~ Error in obbPreparedCallback: " + e.toString());
                            }
                        }

                        return null;
                    }
                });

                break;
            default:
                Log.e(NoodleXBridge.TAG, "OBB~ Invalid download state: " + newState);
        }
	}

	@Override
	public void onDownloadProgress(DownloadProgressInfo progress) {
		if (NoodleXBridge.debug) Log.d(NoodleXBridge.TAG, "OBB~ onDownloadProgress(" + progress.mOverallProgress + ", " + progress.mCurrentSpeed + ")");

        downloadTotal = progress.mOverallTotal;
        downloadProgress = progress.mOverallProgress;
        downloadSpeed = progress.mCurrentSpeed;
        downloadTimeRemaining = progress.mTimeRemaining;

        if (obbDownloadProgressCallback != null) {
            try {
                obbDownloadProgressCallback.call();
            } catch (Exception e) {
                Log.e(NoodleXBridge.TAG, "OBB~ Error in obbDownloadProgressCallback");
            }
        }
	}
	// end IDownloaderClient interface

    /******************
     * FILE RETRIEVAL *
     ******************/
     public static InputStream getInputStreamForFile(String obbFilepath) {
        if (NoodleXBridge.debug) Log.d(NoodleXBridge.TAG, "OBB~ Getting input stream for " + obbFilepath);
        try {
            return expansionFile.getInputStream(obbFilepath);
        } catch (Exception e) {
            Log.e(NoodleXBridge.TAG, "OBB~ Error in getInputStreamForFile " + e.toString());
        }
        return null;
     }

     public static byte[] getBytesForFile(String obbFilepath) {
        if (NoodleXBridge.debug) Log.d(NoodleXBridge.TAG, "OBB~ Getting bytes for " + obbFilepath);
        try {
            InputStream stream = getInputStreamForFile(obbFilepath);
            byte[] data = new byte[stream.available()];
            stream.read(data);
            stream.close();
            return data;
        } catch (Exception e) {
            Log.e(NoodleXBridge.TAG, "OBB~ Error in getBytesForFile");
        }
        return null;
     }

     public static long getOffsetForFile(String obbFilePath) {
        long offset = expansionFile.getAssetFileDescriptor(obbFilePath).getStartOffset();
        return offset;
     }

     public static File extractFile(String obbFilepath, String extractPath) {
        if (NoodleXBridge.debug) Log.d(NoodleXBridge.TAG, "OBB~ Extracting file " + obbFilepath + " to location " + extractPath);
        File unpacked = new File(extractPath);

        //make sure releavant parent folders exist
        File parent = unpacked.getParentFile();
        if(!parent.exists() && !parent.mkdirs()){
            Log.e(NoodleXBridge.TAG, "OBB~ Failed to extract file " + obbFilepath + " to " + extractPath + " - could not create parent directories");
            return null;
        }

        byte[] buffer = getBytesForFile(obbFilepath);

        try {
            FileOutputStream outStream = new FileOutputStream(unpacked);
            outStream.write(buffer);
            outStream.close();
        } catch (Exception e) { 
            Log.e(NoodleXBridge.TAG, "OBB~ Failed to extract file " + obbFilepath + " to " + extractPath);
            return null;
        }

        return unpacked;
     }

     public static void extractEntireObb(String extractPath) {
         if (NoodleXBridge.debug) Log.d(NoodleXBridge.TAG, "OBB~ Extracting entire obb to " + extractPath);
         //TODO
         Log.e(NoodleXBridge.TAG, "OBB~ extractEntireObb NOT IMPLEMENTED");
     }

     public static void deleteObb() {
         if (NoodleXBridge.debug) Log.d(NoodleXBridge.TAG, "OBB~ Deleting obb file...");
        //TODO
        Log.e(NoodleXBridge.TAG, "OBB~ deleteObb NOT IMPLEMENTED");
     }
}